{ open Parser }

rule token =
	parse 
		[' ' '\t' '\r' '\n']	{token lexbuf}
	 |	'+'						{ PLUS }
	 |	'-'						{ MINUS }
	 |	'*'						{ TIMES }
	 |	'/'						{ DIVIDE }
	 |	'('						{ LPAREN }
	 |	')'						{ RPAREN }
	 |	"if"					{ IF }
	 |	"=="					{ EQUAL }
	 |	"<"						{ LESS }
	 |	">"						{ GREATER }

	 |	['0'-'9']+ as lit		{ LITERAL(int_of_string lit) }
	 | ['a'-'z' 'A'-'Z']['a'-'z' 'A'-'Z' '0'-'9' '_']* as lxm { ID(lxm) }
	 |	eof						{ EOF }
	
