{ open Parser }	(* Think so *)

rule token = parse

	[' ' '\t' '\r' '\n']	{ token lexbuf }	(* Whitespace to Remove *)
|	"//"					{ comment lexbuf }	(* Single-Line Comments *)
|	'('						{ LPAREN }			(* Start of Extressions *)
|	')'						{ RPAREN }			(* End of Expressions , RETURNS something*)
|	'+'      				{ PLUS }			(* Addition Operator *)
|	'-'      				{ MINUS }			(* Subtraction Operator *)
|	'*'      				{ TIMES }			(* Multiplication Operator *)
|	'/'      				{ DIVIDE }			(* Division Operator *)
|	'='						{ ASSIGN }			(* Assign Operator *)
|	"=="     				{ EQ }				(* Equality Check Operator *)
|	"!="     				{ NEQ }				(* Inequality Check Operator *)
|	'<'      				{ LT }				(* Less than Check Operator *)
|	"<="     				{ LEQ }				(* Less than or Equal to Check Operator *)
|	">"      				{ GT }				(* Greater than Check Operator *)
|	">="     				{ GEQ }				(* Greater than or Equal to Check Operator *)
|	"\'"					{ SQUOTE }			(* Single Quote *)
|	"\""					{ DQUOTE }			(* Double Quote *)
|	"if"     				{ IF }				(* Condition Check Function *)
|	"for"    				{ FOR }				(* Loop for a set of steps Function *)
|	"while"  				{ WHILE }			(* Loop till condition Function *)
|	"print"					{ PRINT }			(* Print a literal *)
|	"input"					{ INPUT }			(* Input a literal *)
|	["true" "false"]		{ BOOLEAN }
|	['0'-'9']+ as lxm		{ INTEGER(int_of_string lxm) }
(*|	LITERALS *)
(*
	for now, I'm setting it as:
	IDs start with capital letters
	FNAMEs start with small letters
*)
|	['A'-'Z']['a'-'z' 'A'-'Z' '0'-'9' '_']* as lxm { ID(lxm) }
(*|	['a'-'z']['a'-'z' 'A'-'Z' '0'-'9' '_']* as lxm { FNAME(lxm) }	*)
| 	eof						{ EOF }				(* End of File *)
| _ as char { raise (Failure("illegal character " ^ Char.escaped char)) }

and comment = parse
	'\n'					{ token lexbuf }
|	_						{ comment lexbuf }

